<?php
/*
 * +----------------------------------------------------------------------+
 * | PEAR Web site version 1.0                                            |
 * +----------------------------------------------------------------------+
 * | Copyright (c) 2003-2004 The PEAR Group                               |
 * +----------------------------------------------------------------------+
 * | This source file is subject to version 2.02 of the PHP license,      |
 * | that is bundled with this package in the file LICENSE, and is        |
 * | available at through the world-wide-web at                           |
 * | http://www.php.net/license/2_02.txt.                                 |
 * | If you did not receive a copy of the PHP license and are unable to   |
 * | obtain it through the world-wide-web, please send a note to          |
 * | license@php.net so we can mail you a copy immediately.               |
 * +----------------------------------------------------------------------+
 * | Authors: Martin Jansen <mj@php.net>                                  |
 * +----------------------------------------------------------------------+
 *
 * $Id: find-documentation.php,v 1.13 2009/01/20 07:53:45 cweiske Exp $
 */

/**
 * Trying to find documentation URLs for PEAR packages in the peardoc Docbook sources
 *
 * @version $Revision: 1.13 $
 */
require_once dirname(dirname(__FILE__)) . '/include/pear-config.php';
require_once 'PEAR.php';
require_once 'VFS.php';
require_once 'VFS/file.php';
require_once 'HTTP/Request2.php';

require_once 'DB.php';

if (!file_exists('en/package')) {
    echo "Please cd into peardoc checkout\n";
    exit(2);
}
$basepath = getcwd() . '/en/package/';

$vfs = new VFS_file(array('vfsroot' => $basepath));

$options = array(
    'persistent' => false,
    'portability' => DB_PORTABILITY_ALL,
);
$dbh =& DB::connect(PEAR_DATABASE_DSN, $options);
if (DB::isError($dbh)) {
    exit(1);
}

$host = 'http://' . PEAR_CHANNELNAME;

$sql = "
    UPDATE packages SET
        doc_link = ?
    WHERE name = ? AND
    (doc_link IS NULL OR doc_link NOT LIKE 'http://%' OR doc_link LIKE '" . $host . "/%')";
$update = $dbh->prepare($sql);

// {{{ readFolder()

function readFolder($folder)
{
    global $vfs, $basepath, $dbh, $update, $host;

    static $level;
    $level++;

    $result = $vfs->listFolder($folder);

    if ($folder == '.') {
        $folder = '';
    }

    foreach ($result as $file) {
       if (is_dir($basepath . $folder . '/' . $file['name'])) {
            if ($folder == '') {
                $newfolder = $file['name'];
            } else {
                $newfolder = $folder . '/' . $file['name'];
            }
            readFolder($newfolder);
            $level--;
        } else {
            if ($level == 2 && preg_match("/\.xml$/", $file['name'])) {

                $path = $basepath . $folder . '/' . $file['name'];
                $content = file_get_contents($path);

                preg_match("/<title>(.*)<\/title>/", $content, $matches1);
                preg_match("/<sect1 id\=\"(.*)\">/", $content, $matches2);

                $url = '/manual/en/' . $matches2[1] . '.php';

                $a = new HTTP_Request2($host . $url);
                $a->send();

                if ($a->getStatus() == 404) {
                    $new_url = preg_replace("=\.([^\.]+)\.php$=", ".php", $url);
                    $a->reset($host . $new_url);
                    $a->setURL($host . $new_url);
                    $a->send();
                    $url = $a->getStatus() != 404 ? $new_url : '';
                }

                $res = $dbh->execute($update, array($url, $matches1[1]));
            }
        }
    }
}

// }}}

readFolder('.');